from abc import ABC, abstractmethod
from typing import Optional, Union

from cpl_query.extension import List

from py_to_uxf_core.model.class_implementation import ClassImplementation
from py_to_uxf_core.model.python_class import PythonClass


class ImplementationScannerABC(ABC):

    @abstractmethod
    def __init__(self): pass

    @abstractmethod
    def scan_line_for_implementation(self, line: str, classes: list[PythonClass]) -> Union[Optional[ClassImplementation], List[ClassImplementation]]: pass
