import os

from cpl_core.configuration import ConfigurationABC
from cpl_core.console import Console
from cpl_query.extension import List

from py_to_uxf_core.abc.file_scanner_abc import FileScannerABC


class FileScannerService(FileScannerABC):

    def __init__(self, config: ConfigurationABC):
        FileScannerABC.__init__(self)
        self._config = config
        self._path = config.get_configuration('p')

    def scan_files(self) -> List[str]:
        files = List(str)

        for r, d, f in os.walk(self._path):
            for file_name in f:
                if file_name.endswith('.py'):
                    relative_path = os.path.relpath(r)
                    file_path = os.path.join(relative_path, os.path.relpath(file_name))
                    files.append(os.path.relpath(file_path))

        return files
